
BFC_ICON_NORMALPLAYER = "";
BFC_ICON_PARTYPLAYER = "";
BFC_ICON_DEADPLAYER = "";
BFC_ICON_COMBATPLAYER = "";



local BFC_GroupIcons = {
	"Interface\\Addons\\BattlefieldCommander\\images\\group1",
	"Interface\\Addons\\BattlefieldCommander\\images\\group2",
	"Interface\\Addons\\BattlefieldCommander\\images\\group3",
	"Interface\\Addons\\BattlefieldCommander\\images\\group4",
	"Interface\\Addons\\BattlefieldCommander\\images\\group5",
	"Interface\\Addons\\BattlefieldCommander\\images\\group6",
	"Interface\\Addons\\BattlefieldCommander\\images\\group7",
	"Interface\\Addons\\BattlefieldCommander\\images\\group8",
};

local BFC_MiscIcons = {
	combat = "Interface\\Addons\\BattlefieldCommander\\images\\blip-fullred",
	locator = "Interface\\Addons\\BattlefieldCommander\\images\\locator",
	radio = "Interface\\Addons\\BattlefieldCommander\\images\\radio",
	dead = "Interface\\Addons\\BattlefieldCommander\\images\\blip-black",
};

BATTLEFIELD_TAB_SHOW_DELAY = 0.2;
BATTLEFIELD_TAB_FADE_TIME = 0.15;
DEFAULT_BATTLEFIELD_TAB_ALPHA = 0.75;
DEFAULT_POI_ICON_SIZE = 12;
BATTLEFIELD_MINIMAP_UPDATE_RATE = 0.1;
NUM_BATTLEFIELDMAP_POIS = 0;
NUM_BATTLEFIELDMAP_OVERLAYS = 0;

BFC_DebugEnabled = true;
BFC_InCombat = {};

BattlefieldMinimapDefaults = {
	opacity = 0.7,
	locked = false,
	showPlayers = true,
--	position = {
--	x = 100,
--	y = 100},
	size = {
	w = 175,
	h = 131},
};

BFC_ConfigDefaults = {
	version = 1.4,
	channel = "",
	narrow = false,
	enableRadio = true,
	autoShowBg = false,
};

BFC_RaidRoster = {};

function BattlefieldMinimap_LoadUI_New()
end

BattlefieldMinimap_LoadUI = BattlefieldMinimap_LoadUI_New;

function BattlefieldMinimap_Toggle()
	if ( BattlefieldMinimap:IsVisible() ) then
		BattlefieldMinimap:Hide();
		BFC_Frame:Hide();
	else
		if ( MiniMapBattlefieldFrame.status == "active" ) then
			BattlefieldMinimap:Show();
			BFC_Frame:Show();
		end
	end
end

function BattlefieldMinimap_OnLoad()
	this:RegisterEvent("ADDON_LOADED");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("PLAYER_LOGOUT");
	this:RegisterEvent("WORLD_MAP_UPDATE");
	this:RegisterEvent("CHAT_MSG_CHANNEL");
	this:RegisterEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE"); 
    this:RegisterEvent("CHAT_MSG_BG_SYSTEM_HORDE"); 
    this:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL");
	this:RegisterEvent("RAID_ROSTER_UPDATE");
	this:RegisterEvent("PARTY_MEMBERS_CHANGED");
	this:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	this:RegisterEvent("CHAT_MSG_RAID");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");

	CreateMiniWorldMapArrowFrame(BFC_Frame);

	BattlefieldMinimap.updateTimer = 0;
	BattlefieldMinimap.colorUpdateTimer = 0;
end

function BFC_CheckNewOption(name)
	if(not BFC_Config[name]) then
		BFC_Config[name] = BFC_ConfigDefaults[name];
	end
end

function BattlefieldMinimap_OnEvent()
	if ( event == "ADDON_LOADED" ) then
		if ( arg1 == "BattlefieldCommander" ) then
			if ( not BattlefieldMinimapOptions ) then
				BattlefieldMinimapOptions = BattlefieldMinimapDefaults;
			end
			
			if(not BFC_Config) then
				BFC_Config = BFC_ConfigDefaults;
			elseif(not BFC_Config.version or BFC_Config.version < BFC_ConfigDefaults.version) then
				-- handle new options for backwards compatibility
				BFC_CheckNewOption("autoShowBg");
			end
			
			if ( BattlefieldMinimapOptions.position ) then
				BattlefieldMinimapTab:SetPoint("CENTER", "UIParent", "BOTTOMLEFT", BattlefieldMinimapOptions.position.x, BattlefieldMinimapOptions.position.y);
				BattlefieldMinimapTab:SetUserPlaced(true);
			else
				BattlefieldMinimapTab:SetPoint("CENTER", "UIParent", "CENTER", 0,0);
			end
			
			if( BattlefieldMinimapOptions.size ~= nil) then
				
				BattlefieldMinimap:SetWidth(BattlefieldMinimapOptions.size.w);
				BattlefieldMinimap:SetHeight(BattlefieldMinimapOptions.size.h);

				BattlefieldMinimap_ResizeElements();
				BattlefieldMinimap_SnapResizeAnchor();

			end

			UIDropDownMenu_Initialize(BattlefieldMinimapTabDropDown, BattlefieldMinimapDropDown_Initialize, "MENU");

			OpacityFrameSlider:SetValue(BattlefieldMinimapOptions.opacity);
			BattlefieldMinimap_SetOpacity();
			

			BFC_SetNarrowMode(BFC_Config.narrow);

			
			-- Register the slash commands
			SLASH_BFC1 = "/bfc";
			SlashCmdList["BFC"] = function(msg)
				BattlefieldMinimap_SlashCommand(msg);
			end
			SLASH_BFCCHAN1 = "/bfcchan";
			SlashCmdList["BFCCHAN"] = function(msg)
				BFC_ShowChannelDialog();
				--BFC_JoinChannel(msg);
			end
		end
	elseif(event == "RAID_ROSTER_UPDATE") then
		BFC_UpdateRaidRoster();
		BFC_ColorizeRaidIcons();
	elseif(event == "PARTY_MEMBERS_CHANGED") then
		BFC_ColorizeRaidIcons();
	elseif ( event == "PLAYER_ENTERING_WORLD" ) then
		BFC_UpdateRaidRoster();
		if( BFC_Config.autoShowBg == true and MiniMapBattlefieldFrame.status == "active" ) then
			BattlefieldMinimap:Show();
			BFC_Frame:Show();
		elseif ( MiniMapBattlefieldFrame.status ~= "active" ) then
			BattlefieldMinimap:Hide();
		elseif ( BattlefieldMinimap:IsShown() ) then
			SetMapToCurrentZone();
		end
	elseif ( event == "PLAYER_LOGOUT" ) then
		if ( BattlefieldMinimapTab:IsUserPlaced() ) then
			if ( not BattlefieldMinimapOptions.position ) then
				BattlefieldMinimapOptions.position = {};
			end
			BattlefieldMinimapOptions.position.x, BattlefieldMinimapOptions.position.y = BattlefieldMinimapTab:GetCenter();
			
			if ( not BattlefieldMinimapOptions.size ) then
				BattlefieldMinimapOptions.size = {};
			end
			BattlefieldMinimapOptions.size.w = BattlefieldMinimap:GetWidth();
			BattlefieldMinimapOptions.size.h = BattlefieldMinimap:GetHeight();
			
			BattlefieldMinimapTab:SetUserPlaced(false);
		else
			BattlefieldMinimapOptions.position = nil;
		end
		
		
	elseif ( event == "WORLD_MAP_UPDATE" or event == "ZONE_CHANGED_NEW_AREA") then
		if ( BattlefieldMinimap:IsShown() ) then
			--SetMapToCurrentZone();
			BattlefieldMinimap_Update();
		end
	elseif ( event == "PLAYER_TARGET_CHANGED" ) then
		if (UnitExists("target")) then
			BFC_OnTargetChanged();
		end
	elseif ( event == "CHAT_MSG_CHANNEL" ) then
		BFC_ParseChatMessage(arg1, arg2);
	-- TODO: handle CHAT_MSG_PARTY channel broadcast
	elseif ( event == "CHAT_MSG_RAID" ) then
		if(string.sub(arg1, 0, 5) ~= "<BFC>") then return end
		if(BFC_RaidRoster[arg2] == nil) then return end
		if(BFC_RaidRoster[arg2].rank > 0) then
			local _, _, chan = string.find(arg1, BFC_Strings.pattern_broadcastchan);
			if ( chan ) then
				if ( chan ~= BFC_Config.channel and BFC_Config.channel ) then
					LeaveChannelByName(BFC_Config.channel);
				end
				BFC_Config.channel = chan;
				BFC_Frame.joinchan = true;

				BFC_Print(string.format(BFC_Strings.msg_setchannel, chan));
			end
			return;
		end
	end
end

-- Slash command handlers
function BattlefieldMinimap_SlashCommand(msg)
	if(msg == "reset") then
		BFC_ResetPositionAndSize();
	end

	BattlefieldMinimap:Show();
	BFC_Frame:Show();

end

function BFC_ResetPositionAndSize()
	BattlefieldMinimapTab:ClearAllPoints();
	BattlefieldMinimapTab:SetPoint("CENTER", "UIParent", "CENTER", 0, 0);
	BattlefieldMinimapTab:SetUserPlaced(true);

	BattlefieldMinimap:SetWidth(BattlefieldMinimapDefaults.size.w);
	BattlefieldMinimap:SetHeight(BattlefieldMinimapDefaults.size.h);
	
	BattlefieldMinimap_ResizeElements();
	BattlefieldMinimap_SnapResizeAnchor();
end

function BattlefieldMinimap_Update()
	BattlefieldMinimap_ResizeElements();
	BattlefieldMinimap_SnapResizeAnchor();
	BFC_ColorizeRaidIcons();
	
	return;
end

function BFC_CorrectXCoord(x)
	--BFC_Debug("correct got x " .. x);
	local width = BFC_Frame:GetWidth();
	--BFC_Debug("correct got w " .. width);
	x = x * width * 2;

	if(x < width / 2) then
		x = 0;
	else
		x = x - width / 2;
	end
	
	if(x > width) then
		x = width;
	end
	
	return x;
end

function BattlefieldMinimap_ResizeElements()

	-- Set up the size
	local sizeUnit;
	local unitScale;
	local fullwidth = BattlefieldMinimap:GetWidth();

	if(fullwidth < 100) then
		fullwidth = 100;
	end
	if(BFC_Config.narrow) then
		sizeUnit = fullwidth/2;
		unitScale = sizeUnit/256;
	else
		sizeUnit = fullwidth/4;
		unitScale = sizeUnit/256;
		sizeUnit = sizeUnit + 5.5*unitScale; -- compensates for the gap at edge of map
	end
	
	BFC_Frame:ClearAllPoints();
	BFC_Frame:SetPoint("TOPLEFT", BattlefieldMinimap, "TOPLEFT");
	
	
	local mapscale = sizeUnit/256;
	local fullheight = sizeUnit*3- mapscale*100;
	
	BFC_Frame:SetWidth(fullwidth);
	BFC_Frame:SetHeight(fullheight);

	-- Fill in map tiles
	local mapFileName, textureHeight = GetMapInfo();
	if ( not mapFileName ) then
		return;
	end

	local mapPiece;
	BFC_Frame:SetParent(BattlefieldMinimap);
	for i=1, NUM_WORLDMAP_DETAIL_TILES do
		mapPiece = getglobal("BattlefieldMinimap"..i);
		mapPiece:SetTexture("Interface\\WorldMap\\"..mapFileName.."\\"..mapFileName..i);
		mapPiece:SetWidth(sizeUnit);
		mapPiece:SetHeight(sizeUnit);
		--mapPiece:SetParent(BFC_Frame);
	end

	-- Setup the POI's
	local numPOIs = GetNumMapLandmarks();
	local name, description, textureIndex, x, y;
	local battlefieldPOI;
	local x1, x2, y1, y2;
	if(NUM_BATTLEFIELDMAP_POIS == nil) then
		NUM_BATTLEFIELDMAP_POIS = 0;
	end

	if ( NUM_BATTLEFIELDMAP_POIS < numPOIs ) then
		for i=NUM_BATTLEFIELDMAP_POIS+1, numPOIs do
			BattlefieldMinimap_CreatePOI(i);
		end
		NUM_BATTLEFIELDMAP_POIS = numPOIs;
	end
	for i=1, NUM_BATTLEFIELDMAP_POIS, 1 do
		battlefieldPOI = getglobal("BattlefieldMinimapPOI"..i);
		if ( i <= numPOIs ) then
			name, description, textureIndex, x, y = GetMapLandmarkInfo(i);
			x1, x2, y1, y2 = WorldMap_GetPOITextureCoords(textureIndex);
			getglobal(battlefieldPOI:GetName().."Texture"):SetTexCoord(x1, x2, y1, y2);
			
			if(BFC_Config.narrow) then
				x = BFC_CorrectXCoord(x);
				y = -y * fullheight;
			else
				x = x * fullwidth;
				y = -y * fullheight;
			end

			battlefieldPOI:SetPoint("CENTER", "BattlefieldMinimap", "TOPLEFT", x, y );
			battlefieldPOI:SetWidth(DEFAULT_POI_ICON_SIZE * GetBattlefieldMapIconScale());
			battlefieldPOI:SetHeight(DEFAULT_POI_ICON_SIZE * GetBattlefieldMapIconScale());
			battlefieldPOI:Show();
		else
			battlefieldPOI:Hide();
		end
	end

	-- Setup the overlays
	local numOverlays = GetNumMapOverlays();
	local textureName, textureWidth, textureHeight, offsetX, offsetY, mapPointX, mapPointY;
	local textureCount = 0, neededTextures;
	local texture;
	local texturePixelWidth, textureFileWidth, texturePixelHeight, textureFileHeight;
	local numTexturesWide, numTexturesTall;
	-- Use this value to scale the texture sizes and offsets
	local battlefieldMinimapScale = BattlefieldMinimap1:GetWidth()/256;
	for i=1, numOverlays do
		textureName, textureWidth, textureHeight, offsetX, offsetY, mapPointX, mapPointY = GetMapOverlayInfo(i);
		numTexturesWide = ceil(textureWidth/256);
		numTexturesTall = ceil(textureHeight/256);
		neededTextures = textureCount + (numTexturesWide * numTexturesTall);
		if ( neededTextures > NUM_BATTLEFIELDMAP_OVERLAYS ) then
			for j=NUM_BATTLEFIELDMAP_OVERLAYS+1, neededTextures do
				BattlefieldMinimap:CreateTexture("BattlefieldMinimapOverlay"..j, "ARTWORK");
				getglobal("BattlefieldMinimapOverlay"..j):SetParent(BFC_Frame);
			end
			NUM_BATTLEFIELDMAP_OVERLAYS = neededTextures;
		end
		for j=1, numTexturesTall do
			if ( j < numTexturesTall ) then
				texturePixelHeight = 256;
				textureFileHeight = 256;
			else
				texturePixelHeight = mod(textureHeight, 256);
				if ( texturePixelHeight == 0 ) then
					texturePixelHeight = 256;
				end
				textureFileHeight = 16;
				while(textureFileHeight < texturePixelHeight) do
					textureFileHeight = textureFileHeight * 2;
				end
			end
			for k=1, numTexturesWide do
				textureCount = textureCount + 1;
				texture = getglobal("BattlefieldMinimapOverlay"..textureCount);
				--texture:SetParent(BFC_Frame);
				--texture:SetParent(BattlefieldMinimap);
				if ( k < numTexturesWide ) then
					texturePixelWidth = 256;
					textureFileWidth = 256;
				else
					texturePixelWidth = mod(textureWidth, 256);
					if ( texturePixelWidth == 0 ) then
						texturePixelWidth = 256;
					end
					textureFileWidth = 16;
					while(textureFileWidth < texturePixelWidth) do
						textureFileWidth = textureFileWidth * 2;
					end
				end
				--texture:SetWidth(texturePixelWidth*battlefieldMinimapScale);
				--texture:SetHeight(texturePixelHeight*battlefieldMinimapScale);
				--texture:SetTexCoord(0, texturePixelWidth/textureFileWidth, 0, texturePixelHeight/textureFileHeight);
				--texture:SetPoint("TOPLEFT", "BattlefieldMinimap", "TOPLEFT", (offsetX + (256 * (k-1)))*battlefieldMinimapScale, -((offsetY + (256 * (j - 1)))*battlefieldMinimapScale));
				--texture:SetTexture(textureName..(((j - 1) * numTexturesWide) + k));
				--texture:Show();
				local texoffset1 = 0;
				local texoffset2 = texturePixelWidth/textureFileWidth;
				
				local xpos = (offsetX + (256 * (k-1)));
				texture:Show();
				if(BFC_Config.narrow) then
					xpos = xpos - 256;
					if(xpos < 0) then
						if(xpos == -256) then
							texture:Hide();
						else
							texoffset1 = 1-((texturePixelWidth+xpos)/textureFileWidth);
							texture:SetWidth((texturePixelWidth+xpos)*battlefieldMinimapScale);
							xpos = 0;
						end
					elseif(xpos + texturePixelWidth >= 512) then
						if(xpos >= 512) then
							texture:Hide();
						else
							local extra = (xpos + texturePixelWidth) - 512;
							texoffset2 = ((texturePixelWidth - extra)/textureFileWidth);
							texture:SetWidth((texturePixelWidth - extra)*battlefieldMinimapScale);
						end
					else
						texture:SetWidth(texturePixelWidth*battlefieldMinimapScale);
					end
					
					xpos = xpos * battlefieldMinimapScale;
					
				else
					xpos = xpos * battlefieldMinimapScale;
					texture:SetWidth(texturePixelWidth*battlefieldMinimapScale);
				end
				
				texture:SetHeight(texturePixelHeight*battlefieldMinimapScale);
				texture:SetTexCoord(texoffset1, texoffset2, 0, texturePixelHeight/textureFileHeight);

				texture:ClearAllPoints();
				texture:SetPoint("TOPLEFT", "BattlefieldMinimap", "TOPLEFT", xpos, -((offsetY + (256 * (j - 1)))*battlefieldMinimapScale));
				texture:SetTexture(textureName..(((j - 1) * numTexturesWide) + k));			
				
			end
		end
	end
	for i=textureCount+1, NUM_BATTLEFIELDMAP_OVERLAYS do
		getglobal("BattlefieldMinimapOverlay"..i):Hide();
	end
	
end

-- this will always be called, even when BFC is hidden
function BFC_OnUpdate(elapsed)

	-- Join channel if needed (sometimes the channel doesn't join when you ask it,
	-- so it's in onUpdate to ensure it's joined)
	if(BFC_Frame.joinchan == true) then
		-- easy out if we're already in the channel or channel name is missing
		if((BFC_Config.channel == nil) or (GetChannelName(BFC_Config.channel) ~= 0)) then
			BFC_Frame.joinchan = false;
			return;
		end
		
		JoinChannelByName(BFC_Config.channel);
	end
end

function BattlefieldMinimap_CreatePOI(index)
	local frame = CreateFrame("Frame", "BattlefieldMinimapPOI"..index, BFC_Frame);
	frame:SetWidth(DEFAULT_POI_ICON_SIZE);
	frame:SetHeight(DEFAULT_POI_ICON_SIZE);
	--frame:SetParent(BFC_Frame);
	frame:SetFrameLevel(BFC_Frame:GetFrameLevel() + 2);
	local texture = frame:CreateTexture(frame:GetName().."Texture", "BACKGROUND");
	--texture:SetParent(frame);
	texture:SetAllPoints(frame);
	texture:SetTexture("Interface\\Minimap\\POIIcons");
end

function BattlefieldMinimap_OnUpdate(elapsed)

	-- Throttle updates
	if ( BattlefieldMinimap.updateTimer < 0 ) then
		BattlefieldMinimap.updateTimer = BATTLEFIELD_MINIMAP_UPDATE_RATE;
	else
		BattlefieldMinimap.updateTimer = BattlefieldMinimap.updateTimer - elapsed;
		return;
	end
	
	
	
	-- Update colors every second
	if ( BattlefieldMinimap.colorUpdateTimer < 0 ) then
		BattlefieldMinimap.colorUpdateTimer = 1.0;
		BFC_ColorizeRaidIcons();
	else
		BattlefieldMinimap.colorUpdateTimer = BattlefieldMinimap.colorUpdateTimer - elapsed;
	end
	
	--Position player
	UpdateWorldMapArrowFrames();
	local playerX, playerY = GetPlayerMapPosition("player");
	if ( playerX == 0 and playerY == 0 ) then
		ShowMiniWorldMapArrowFrame(nil);
	else
		if(BFC_Config.narrow) then
			playerX = BFC_CorrectXCoord(playerX);
		else
			playerX = playerX * BFC_Frame:GetWidth();
		end
		playerY = -playerY * BFC_Frame:GetHeight();
		PositionMiniWorldMapArrowFrame("CENTER", "BFC_Frame", "TOPLEFT", playerX, playerY);
		ShowMiniWorldMapArrowFrame(1);
		BattlefieldMinimapPlayer:SetPoint("CENTER", "BFC_Frame", "TOPLEFT", playerX, playerY);
	end
	
	-- If resizing the frame then scale everything accordingly
	if ( BattlefieldMinimap.resizing ) then
		BattlefieldMinimap_ResizeElements();
	end

	if ( not BattlefieldMinimapOptions.showPlayers ) then
		for i=1, MAX_PARTY_MEMBERS do
			getglobal("BattlefieldMinimapParty"..i):Hide();
		end
		for i=1, MAX_RAID_MEMBERS do
			getglobal("BattlefieldMinimapRaid"..i):Hide();
		end
	else
		--Position groupmates
		local partyX, partyY, partyMemberFrame;
		local playerCount = 0;
		if ( GetNumRaidMembers() > 0 ) then
			for i=1, MAX_PARTY_MEMBERS do
				partyMemberFrame = getglobal("BattlefieldMinimapParty"..i);
				partyMemberFrame:Hide();
			end
			for i=1, MAX_RAID_MEMBERS do
				partyX, partyY = GetPlayerMapPosition("raid"..i);
				partyMemberFrame = getglobal("BattlefieldMinimapRaid"..playerCount + 1);
				if ( (partyX ~= 0 or partyY ~= 0) and not UnitIsUnit("raid"..i, "player") ) then
					if(BFC_Config.narrow) then
						partyX = BFC_CorrectXCoord(partyX);
					else
						partyX = partyX * BFC_Frame:GetWidth();
					end
					partyY = -partyY * BFC_Frame:GetHeight();
					partyMemberFrame:SetPoint("CENTER", "BattlefieldMinimap", "TOPLEFT", partyX, partyY);
					partyMemberFrame.name = nil;
					partyMemberFrame:Show();
					playerCount = playerCount + 1;
				end
			end
		else
			for i=1, MAX_PARTY_MEMBERS do
				partyX, partyY = GetPlayerMapPosition("party"..i);
				partyMemberFrame = getglobal("BattlefieldMinimapParty"..i);
				if ( partyX == 0 and partyY == 0 ) then
					partyMemberFrame:Hide();
				else
					if(BFC_Config.narrow) then
						partyX = BFC_CorrectXCoord(partyX);
					else
						partyX = partyX * BFC_Frame:GetWidth();
					end
					partyY = -partyY * BFC_Frame:GetHeight();
					partyMemberFrame:SetPoint("CENTER", "BattlefieldMinimap", "TOPLEFT", partyX, partyY);
					partyMemberFrame:Show();
				end
			end
		end
		-- Position Team Members
		local numTeamMembers = GetNumBattlefieldPositions();
		for i=playerCount+1, MAX_RAID_MEMBERS do
			partyX, partyY, name = GetBattlefieldPosition(i - playerCount);
			partyMemberFrame = getglobal("BattlefieldMinimapRaid"..i);
			if ( partyX == 0 and partyY == 0 ) then
				partyMemberFrame:Hide();
			else
				if(BFC_Config.narrow) then
					partyX = BFC_CorrectXCoord(partyX);
				else
					partyX = partyX * BFC_Frame:GetWidth();
				end
				partyY = -partyY * BFC_Frame:GetHeight();
				partyMemberFrame:SetPoint("CENTER", "BattlefieldMinimap", "TOPLEFT", partyX, partyY);
				partyMemberFrame.name = name;
				partyMemberFrame:Show();
			end
		end

		-- Position flags
		local flagX, flagY, flagToken, flagFrame, flagTexture;
		local numFlags = GetNumBattlefieldFlagPositions();
		for i=1, NUM_WORLDMAP_FLAGS do
			flagFrame = getglobal("BattlefieldMinimapFlag"..i);
			if ( i <= numFlags ) then
				flagX, flagY, flagToken = GetBattlefieldFlagPosition(i);
				flagTexture = getglobal("BattlefieldMinimapFlag"..i.."Texture");
				if ( flagX == 0 and flagY == 0 ) then
					flagFrame:Hide();
				else
					if(BFC_Config.narrow) then
						flagX = BFC_CorrectXCoord(flagX);
					else
						flagX = flagX * BFC_Frame:GetWidth();
					end
					flagY = -flagY * BFC_Frame:GetHeight();
					flagFrame:SetPoint("CENTER", "BattlefieldMinimap", "TOPLEFT", flagX, flagY);
					flagTexture:SetTexture("Interface\\WorldStateFrame\\"..flagToken);
					flagFrame:Show();
				end
			else
				flagFrame:Hide();
			end
		end
	end

	-- Fadein tab if mouse is over
	if ( MouseIsOver(BattlefieldMinimap, 45, -10, -5, 5) and not UIOptionsFrame:IsVisible()) then
		local xPos, yPos = GetCursorPosition();
		-- If mouse is hovering don't show the tab until the elapsed time reaches the tab show delay
		if ( BattlefieldMinimap.hover ) then
			if ( (BattlefieldMinimap.oldX == xPos and BattlefieldMinimap.oldy == yPos) ) then
				BattlefieldMinimap.hoverTime = BattlefieldMinimap.hoverTime + elapsed;
			else
				BattlefieldMinimap.hoverTime = 0;
				BattlefieldMinimap.oldX = xPos;
				BattlefieldMinimap.oldy = yPos;
			end
			if ( BattlefieldMinimap.hoverTime > BATTLEFIELD_TAB_SHOW_DELAY ) then
				-- If the battlefieldtab's alpha is less than the current default, then fade it in 
				if ( not BattlefieldMinimap.hasBeenFaded and (BattlefieldMinimap.oldAlpha and BattlefieldMinimap.oldAlpha < DEFAULT_BATTLEFIELD_TAB_ALPHA) ) then
					UIFrameFadeIn(BattlefieldMinimapTab, BATTLEFIELD_TAB_FADE_TIME, BattlefieldMinimap.oldAlpha, DEFAULT_BATTLEFIELD_TAB_ALPHA);
					-- Set the fact that the chatFrame has been faded so we don't try to fade it again
					BattlefieldMinimap.hasBeenFaded = 1;
				end
			end
		else
			-- Start hovering counter
			BattlefieldMinimap.hover = 1;
			BattlefieldMinimap.hoverTime = 0;
			BattlefieldMinimap.hasBeenFaded = nil;
			CURSOR_OLD_X, CURSOR_OLD_Y = GetCursorPosition();
			-- Remember the oldAlpha so we can return to it later
			if ( not BattlefieldMinimap.oldAlpha ) then
				BattlefieldMinimap.oldAlpha = BattlefieldMinimapTab:GetAlpha();
			end
		end
	else
		-- If the tab's alpha was less than the current default, then fade it back out to the oldAlpha
		if ( BattlefieldMinimap.hasBeenFaded and BattlefieldMinimap.oldAlpha and BattlefieldMinimap.oldAlpha < DEFAULT_BATTLEFIELD_TAB_ALPHA ) then
			UIFrameFadeOut(BattlefieldMinimapTab, BATTLEFIELD_TAB_FADE_TIME, DEFAULT_BATTLEFIELD_TAB_ALPHA, BattlefieldMinimap.oldAlpha);
			BattlefieldMinimap.hover = nil;
			BattlefieldMinimap.hasBeenFaded = nil;
		end
		BattlefieldMinimap.hoverTime = 0;
	end
end

function BattlefieldMinimap_ShowOpacity()
	OpacityFrame:ClearAllPoints();
	OpacityFrame:SetPoint("TOPRIGHT", "BattlefieldMinimap", "TOPLEFT", 0, 7);
	OpacityFrame.opacityFunc = BattlefieldMinimap_SetOpacity;
	OpacityFrame.saveOpacityFunc = BattlefieldMinimap_SaveOpacity;
	OpacityFrameSlider:SetValue(BattlefieldMinimapOptions.opacity);
	OpacityFrame:Show();
end

function BattlefieldMinimap_SetOpacity()
	local alpha = 1.0 - OpacityFrameSlider:GetValue();
	BattlefieldMinimapBackgroundT:SetAlpha(alpha);
	BattlefieldMinimapBackgroundTL:SetAlpha(alpha);
	BattlefieldMinimapBackgroundTR:SetAlpha(alpha);
	BattlefieldMinimapBackgroundB:SetAlpha(alpha);
	BattlefieldMinimapBackgroundBL:SetAlpha(alpha);
	BattlefieldMinimapBackgroundBR:SetAlpha(alpha);
	BattlefieldMinimapBackgroundL:SetAlpha(alpha);
	BattlefieldMinimapBackgroundR:SetAlpha(alpha);
	BattlefieldMinimapResizeHandleImg:SetAlpha(alpha);
	
	for i=1, NUM_WORLDMAP_DETAIL_TILES do
		getglobal("BattlefieldMinimap"..i):SetAlpha(alpha);
	end
	if ( alpha >= 0.15 ) then
		alpha = alpha - 0.15;
	end
	for i=1, NUM_WORLDMAP_OVERLAYS do
		getglobal("BattlefieldMinimapOverlay"..i):SetAlpha(alpha);
	end
	BattlefieldMinimapCloseButton:SetAlpha(alpha);
	BFC_ExpandCommanderButton:SetAlpha(alpha);
	BattlefieldMinimapCorner:SetAlpha(alpha);
end

function BattlefieldMinimap_SaveOpacity()
	BattlefieldMinimapOptions.opacity = OpacityFrameSlider:GetValue();
end

function BattlefieldMinimapDropDown_Initialize()
	local checked;
	local info = {};
	-- Show battlefield players
	if ( BattlefieldMinimapOptions.showPlayers ) then
		checked = 1;
	end
	info.text = SHOW_BATTLEFIELDMINIMAP_PLAYERS;
	info.func = BattlefieldMinimap_TogglePlayers;
	info.checked = checked;
	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
	
	-- Battlefield minimap lock
	checked = nil;
	if ( BattlefieldMinimapOptions.locked ) then
		checked = 1;
	end
	info.text = LOCK_BATTLEFIELDMINIMAP;
	info.func = BattlefieldMinimap_ToggleLock;
	info.checked = checked;
	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);

	-- Opacity
	info = {};
	info.text = BATTLEFIELDMINIMAP_OPACITY_LABEL;
	info.func = BattlefieldMinimap_ShowOpacity;
	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
	
	-- Narrow mode
	checked = nil;
	if ( BFC_Config.narrow ) then
		checked = 1;
	end
	info = {};
	info.text = BFC_Strings.narrowmode;
	info.func = BFC_ToggleNarrowMode;
	info.checked = checked;
	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
	
	-- Narrow mode
	checked = nil;
	if ( BFC_Config.autoShowBg ) then
		checked = 1;
	end
	info = {};
	info.text = BFC_Strings.autoshowbg;
	info.func = BFC_ToggleAutoShowBG;
	info.checked = checked;
	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
	
	-- Radio sounds
	checked = nil;
	if ( BFC_Config.enableRadio ) then
		checked = 1;
	end
	info = {};
	info.text = BFC_Strings.enableradio;
	info.func = BFC_ToggleRadioSounds;
	info.checked = checked;
	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
	
	-- Channel
	info = {};
	info.text = BFC_Strings.channelmenuitem;
	info.func = BFC_ShowChannelDialog;
	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
	
end

function BattlefieldMinimapTab_OnClick(button)
	-- If Rightclick bring up the options menu
	if ( button == "RightButton" ) then
		ToggleDropDownMenu(1, nil, BattlefieldMinimapTabDropDown, this:GetName(), 0, 0);
		return;
	end

	-- Close all dropdowns
	CloseDropDownMenus();

	-- If frame is not locked then allow the frame to be dragged or dropped
	if ( this:GetButtonState() == "PUSHED" ) then
		BattlefieldMinimapTab:StopMovingOrSizing();
	else
		-- If locked don't allow any movement
		if ( BattlefieldMinimapOptions.locked ) then
			return;
		else
			BattlefieldMinimapTab:StartMoving();
		end
	end
end

function BattlefieldMinimap_ToggleLock()
	BattlefieldMinimapOptions.locked = not BattlefieldMinimapOptions.locked;
end

function BattlefieldMinimap_TogglePlayers()
	BattlefieldMinimapOptions.showPlayers = not BattlefieldMinimapOptions.showPlayers;
end

function BFC_ToggleRadioSounds()
	BFC_Config.enableRadio = not BFC_Config.enableRadio;
end

function BFC_ToggleAutoShowBG()
	BFC_Config.autoShowBg = not BFC_Config.autoShowBg;
end

function BFC_OnTargetChanged()
	if ( not UnitExists("target") ) then
		BFC_LocatorBlip:Hide();
		return;
	end
	
	local x, y = GetPlayerMapPosition("target");

	if(x == 0 or y == 0) then
		BFC_LocatorBlip:Hide();
		return;
	end

	BFC_LocatorBlip:ClearAllPoints();
	if(BFC_Config.narrow) then
		BFC_LocatorBlip:SetPoint("BOTTOMLEFT", "BFC_Frame", "TOPLEFT", BFC_CorrectXCoord(x), -y * BFC_Frame:GetHeight());
	else
		BFC_LocatorBlip:SetPoint("BOTTOMLEFT", "BFC_Frame", "TOPLEFT", x * BFC_Frame:GetWidth() - 8, -y * BFC_Frame:GetHeight() - 8);
	end
	--BFC_LocatorBlip:SetAlpha(255);
	BFC_LocatorBlip:Show();
end

function BFC_LocatorBlip_OnUpdate(time)
	-- FIXME: throttle this
	BFC_OnTargetChanged();
end

function BattlefieldMinimapUnit_OnEnter()
	-- Adjust the tooltip based on which side the unit button is on
	local x, y = this:GetCenter();
	local parentX, parentY = this:GetParent():GetCenter();
	if ( x > parentX ) then
		GameTooltip:SetOwner(this, "ANCHOR_LEFT");
	else
		GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
	end
	
	-- See which POI's are in the same region and include their names in the tooltip
	local unitButton;
	local newLineString = "";
	local tooltipText = "";
	
	-- Check Objectives
	for i=0, 8 do
		unitButton = getglobal("BFC_Objective"..i);
		if ( unitButton:IsVisible() and MouseIsOver(unitButton) ) then
			if(unitButton:GetID() == 0) then
				tooltipText = tooltipText..newLineString..BFC_Strings.yourobjective;
			else
				tooltipText = tooltipText..newLineString..string.format(BFC_Strings.groupobjective, unitButton:GetID());
			end
			newLineString = "\n";
		end
	end
	
	
	-- Check player
	if ( MouseIsOver(BattlefieldMinimapPlayer) ) then
		tooltipText = "|cff00ff00"..UnitName(BattlefieldMinimapPlayer.unit).."|r";
		newLineString = "\n";
	end
	
	-- Check party
	for i=1, MAX_PARTY_MEMBERS do
		unitButton = getglobal("BattlefieldMinimapParty"..i);
		if ( unitButton:IsVisible() and MouseIsOver(unitButton) ) then
			tooltipText = tooltipText..newLineString.."|cff00ff00"..UnitName(unitButton.unit).."|r";
			newLineString = "\n";
		end
	end
	--Check Raid
	for i=1, MAX_RAID_MEMBERS do
		unitButton = getglobal("BattlefieldMinimapRaid"..i);
		if ( unitButton:IsVisible() and MouseIsOver(unitButton) ) then
			-- Handle players not in your raid or party, but on your team
			if ( unitButton.name ) then
				tooltipText = tooltipText..newLineString.."|cff7f7f7f"..unitButton.name.."|r";	
			else
				if(unitButton.samegroup) then
					tooltipText = tooltipText..newLineString.."|cff00ff00"..UnitName(unitButton.unit).."|r";
				else
					if(unitButton.unit and UnitName(unitButton.unit)) then
						tooltipText = tooltipText..newLineString..UnitName(unitButton.unit);
					end
				end
			end
			newLineString = "\n";
		end
	end
	GameTooltip:SetText(tooltipText);
	GameTooltip:Show();
end



function BattlefieldMinimap_SnapResizeAnchor()
		
	--BattlefieldMinimapBackground:SetWidth(BattlefieldMinimap1:GetWidth() * 4);
	--BattlefieldMinimapBackground:SetHeight(BattlefieldMinimap1:GetHeight() * 3);
	--BFC_Debug("srain: full width is " .. BattlefieldMinimap:GetWidth());
	--("srain: full height is " .. BattlefieldMinimap:GetHeight());
	
	BattlefieldMinimap:ClearAllPoints();
	BattlefieldMinimap:SetPoint("TOPLEFT", BattlefieldMinimapTab, "BOTTOMLEFT", 0, -5);
	
	local mapscale = BattlefieldMinimap1:GetWidth()/256;
	
	if(BFC_Config.narrow) then
		BattlefieldMinimap:SetWidth(BattlefieldMinimap1:GetWidth() * 2);
	else
		local newwidth = BattlefieldMinimap1:GetWidth() * 4 - mapscale*22;
		local delta = BattlefieldMinimap:GetWidth() - newwidth;
		--BFC_Debug("Delta = " .. delta);
		if(delta > 0.15) then
			BattlefieldMinimap:SetWidth(newwidth);
		end
	end
	BattlefieldMinimap:SetHeight(BattlefieldMinimap1:GetHeight() * 3 - mapscale*100);
	
	BattlefieldMinimapResizeHandle:ClearAllPoints();
	BattlefieldMinimapResizeHandle:SetPoint("BOTTOMRIGHT", BattlefieldMinimap, "BOTTOMRIGHT");
	
	--BattlefieldMinimapBackground:ClearAllPoints();
	--BattlefieldMinimapBackground:SetPoint("TOPLEFT", BattlefieldMinimap, "TOPLEFT", -12, 12);
	--BattlefieldMinimapBackground:SetPoint("BOTTOMRIGHT", BattlefieldMinimap, "BOTTOMRIGHT");
	
	--BFC_Debug("sraout: full width is " .. BattlefieldMinimap:GetWidth());
	--BFC_Debug("sraout: full height is " .. BattlefieldMinimap:GetHeight());
end

function BFC_ToggleNarrowMode()
	BFC_Config.narrow = not BFC_Config.narrow;
	BFC_SetNarrowMode(BFC_Config.narrow);
end

function BFC_SetNarrowMode(state)

	local oldstate = BFC_Config.narrow;

	if(state) then
		BFC_Config.narrow = true;
		BattlefieldMinimap1:Hide();
		BattlefieldMinimap5:Hide();
		BattlefieldMinimap9:Hide();
		BattlefieldMinimap4:Hide();
		BattlefieldMinimap8:Hide();
		BattlefieldMinimap12:Hide();
		
		BattlefieldMinimap2:ClearAllPoints();
		BattlefieldMinimap2:SetPoint("TOPLEFT", BattlefieldMinimap, "TOPLEFT");
		if(oldstate == false) then
			BattlefieldMinimap:SetWidth(BattlefieldMinimap:GetWidth() / 2);
		end
		
		BattlefieldMinimap_ResizeElements();
		BattlefieldMinimap_SnapResizeAnchor();
	else
		BFC_Config.narrow = false;
		BattlefieldMinimap1:Show();
		BattlefieldMinimap5:Show();
		BattlefieldMinimap9:Show();
		BattlefieldMinimap4:Show();
		BattlefieldMinimap8:Show();
		BattlefieldMinimap12:Show();
		
		BattlefieldMinimap2:ClearAllPoints();
		BattlefieldMinimap2:SetPoint("TOPLEFT", BattlefieldMinimap1, "TOPRIGHT");
		if(oldstate == true) then
			BattlefieldMinimap:SetWidth(BattlefieldMinimap:GetWidth() * 2);
		end
		
		BattlefieldMinimap_ResizeElements();
		BattlefieldMinimap_SnapResizeAnchor();
	end
end


function BFC_Debug(msg)
	if(BFC_DebugEnabled == true) then
		BFC_Print(msg);
	end
end

function BFC_Print(msg)
	if (DEFAULT_CHAT_FRAME) then
		DEFAULT_CHAT_FRAME:AddMessage("<BFC> " .. msg);
	end
end

-- Process an incoming ping request
function BFC_HandlePingRequest(msg)
	
	local comma,_ = string.find(msg, ",");
	local space,_ = string.find(msg, " ");
	local x = string.sub(msg, 0, comma-1);
	local y = string.sub(msg, comma + 1, space - 1);
	msg = string.sub(msg, space + 1);
	
	BFC_PingX = tonumber(x);
	BFC_PingY = tonumber(y);
	BFC_DrawPing(BFC_PingX, BFC_PingY, true);
	BFC_Ping.timer = MINIMAPPING_TIMER;

end

-- Process an incoming radio request
function BFC_HandleRadioRequest(msg)
	if(BFC_Config.enableRadio == false) then return end
	local slash = string.find(msg, "/");
	local race;
	
	-- slash check in here to preserve compatibility
	-- with pre-release versions that are out there
	if(slash == nil) then
		race = "Human"
	else
		race = string.sub(msg, 0, slash-1);
		msg = string.sub(msg, slash + 1);
	end

	PlaySoundFile(BFC_Radio[race][msg]);

end


-- Draw a ping at the specified location
function BFC_DrawPing(x,y, playsound)
	if(not BattlefieldMinimap:IsShown()) then return end
	
	if(x == nil) then
		return;
	end

	
	BFC_Ping:ClearAllPoints();
	if(BFC_Config.narrow) then
		BFC_Ping:SetPoint("CENTER", "BFC_Frame", "TOPLEFT", BFC_CorrectXCoord(x) - 8, -y * BFC_Frame:GetHeight() - 8);
	else
		BFC_Ping:SetPoint("CENTER", "BFC_Frame", "TOPLEFT", x * BFC_Frame:GetWidth() - 8, -y * BFC_Frame:GetHeight() - 8);
	end
	BFC_Ping:SetAlpha(255);
	BFC_Ping:Show();
	
	if(playsound) then
		PlaySound("MapPing");
	end
end


-- Handle an incoming objective request
function BFC_HandleObjectiveRequest(msg)
	local comma,_ = string.find(msg, ",");
	local space,_ = string.find(msg, " ");
	local x = string.sub(msg, 0, comma-1);
	local y = string.sub(msg, comma + 1, space - 1);
	msg = string.sub(msg, space + 1);
	BFC_Print(msg);
	space,_ = string.find(msg, " ");
	local num = string.sub(msg, space + 1);
	local pname = UnitName("player");
	if((GetNumRaidMembers() > 0) and (BFC_CanSendObjective(pname) == false)) then
		if(BFC_RaidRoster[pname] and (BFC_RaidRoster[pname].subgroup == tonumber(num))) then
			BFC_DrawObjective(tonumber(x), tonumber(y), tonumber(num), string.sub(msg, 0, space - 1), false);
		end
	else
		BFC_DrawObjective(tonumber(x), tonumber(y), tonumber(num), string.sub(msg, 0, space - 1), false);
	end
end

function BFC_HandleClearObjectivesRequest(msg)
	-- TODO: if groupnum == msg  clear objectivelineBFC_ObjectiveLine:Hide();
	getglobal("BFC_Objective" .. msg):Hide();
end

function BFC_PlaceObjective(objective,x,y)
	--if(BFC_Options.EnablePings == false) then return end
	
	
	local centerX, centerY = BFC_Frame:GetCenter();
	x = x / BFC_Frame:GetEffectiveScale();
	y = y / BFC_Frame:GetEffectiveScale();

	local width = BFC_Frame:GetWidth();
	local height = BFC_Frame:GetHeight();
	
	if(BFC_Config.narrow) then
		width = width*2;
	end
	
	x = (x - (centerX - (width/2))) / width;
	y = (centerY + (height/2) - y) / height;

	--BFC_SelectedObjective = "shield";
	
	
	if(objective == "ping") then
		BFC_SendChannelMessage("PING " .. x .. "," .. y .. " ");
	else
		for i = 1,8 do
			if(getglobal("BFC_GroupButton" .. i ):GetChecked()) then
				BFC_SendChannelMessage("OJTV " .. x .. "," .. y .. " " .. objective .. " " .. i);
			end
		end
	end
end

function BFC_DrawObjective(x, y, num, file, playsound)

	local frame = getglobal("BFC_Objective" .. num);
	
	if(file == "shield") then
		BFC_Print(BFC_Strings["defendcommand"]);
	elseif(file == "sword") then
		BFC_Print(BFC_Strings["attackcommand"]);
	end
	
	local tex = getglobal("BFC_Objective" .. num .. "Texture");
	tex:SetTexture("Interface\\Addons\\BattlefieldCommander\\" .. file);
	
	tex.rawX = x;
	tex.rawY = y;
	
	frame:ClearAllPoints();
	
	if(BFC_Config.narrow) then
		frame:SetPoint("CENTER", "BattlefieldMinimap", "TOPLEFT", BFC_CorrectXCoord(x), -y * BattlefieldMinimap:GetHeight());
	else
		frame:SetPoint("CENTER", "BattlefieldMinimap", "TOPLEFT", x * BattlefieldMinimap:GetWidth(), -y * BattlefieldMinimap:GetHeight());
	end
	frame:SetAlpha(255);
	frame:Show();
	
	if(playsound) then
		PlaySound("MapPing");
	end
	
	--BFC_ObjectiveLine:Show();
end

function BFC_HideObjective(num)
	local frame = getglobal("BFC_Objective" .. num);
	frame:Hide();
	BFC_ObjectiveLine:Hide();
end


-- This function is almost word for word from the MapNotes function
-- that does the same thing.  I hadn't even considered this approach!
-- Hats off to them for it.    ... I even used their line images!
function BFC_DrawObjectiveLine(id, x1, y1, x2, y2)
    local tex = getglobal("BFC_ObjectiveLine" .. id .. "Texture");

    -- Establish the horizontal and vertical difference between the
    -- two endpoints.
    local dx = abs((x1 - x2) * BattlefieldMinimap:GetWidth());
    local dy = abs((y1 - y2) * BattlefieldMinimap:GetHeight());

    -- If either of these is smaller than the texture size, the
    -- texture should be clipped to suit.
    local clipsize = dx;
    if (dy < dx) then clipsize = dy; end

    -- Normalise the clipping size, and clamp it to 0 - 1
    clipsize = clipsize / 256; -- 256 is the size of the texture
    if (clipsize > 1) then clipsize = 1; end

    -- There are now four cases to draw.
    --  1) Point 1 is ABOVE and to the LEFT of point 2;
    --  2) Point 1 is ABOVE and to the RIGHT of point 2;
    --  3) Point 1 is BELOW and to the LEFT of point 2;
    --  4) Point 1 is BELOW and to the RIGHT of point 2;
    -- The case determines which diagonal line texture you need.
    -- (Technically, fully horizontal and fully vertical lines would
    --  need their own textures, but this hasn't come up yet!)

    -- If point 1 is to the right of point 2, swap them; this reduces
    -- the number of cases to two (y1 > y2 or y2 > y1).
    if (x1 > x2) then
        x1, y1, x2, y2 = x2, y2, x1, y1;
    end

    -- Figure out UP or DOWN texture
    if (y1 < y2) then
        tex:SetTexture("Interface\\Addons\\BattlefieldCommander\\linedown");
        tex:SetTexCoord(0, clipsize, 0, clipsize);
        tex:SetPoint("TOPLEFT", "BattlefieldMinimap", "TOPLEFT",
            x1 * BattlefieldMinimap:GetWidth(),
            -y1 * BattlefieldMinimap:GetHeight());

    else
        tex:SetTexture("Interface\\Addons\\BattlefieldCommander\\lineup");
        tex:SetTexCoord(0, clipsize, 1 - clipsize, 1);
        tex:SetPoint("TOPLEFT", "BattlefieldMinimap", "TOPLEFT",
            x1 * BattlefieldMinimap:GetWidth(),
            -(y1 * BattlefieldMinimap:GetHeight() - dy));
    end
    tex:SetWidth(dx);
    tex:SetHeight(dy);
    tex:Show();
end


-- notify when we enter or exit combat
function BFC_EnterCombat()
	BFC_SendChannelMessage("ECBT");
end

function BFC_LeaveCombat()
	BFC_SendChannelMessage("LCBT");
end


-- update a player's blip to show that they're in or out of combat
function BFC_PlayerEnterCombat(name)
	BFC_InCombat[name] = 1;
end

function BFC_PlayerLeaveCombat(name)
	BFC_InCombat[name] = 0;
end

-- mostly based on the stock minimap ping code
function BFC_Ping_OnLoad()
	BFC_Ping.fadeOut = nil;
	this:SetSequence(0);
end

function BFC_Ping_OnUpdate(elapsed)

	if ( BFC_Ping.timer and BFC_Ping.timer > 0 ) then
		BFC_Ping.timer = BFC_Ping.timer - elapsed;
		if (BFC_Ping.timer <= 0 ) then
			BFC_Ping_FadeOut();
		else
			BFC_DrawPing(BFC_PingX, BFC_PingY);
		end
	elseif ( BFC_Ping.fadeOut ) then
		BFC_Ping.fadeOutTimer = BFC_Ping.fadeOutTimer - elapsed;
		if ( BFC_Ping.fadeOutTimer > 0 ) then
			BFC_Ping:SetAlpha(255 * (BFC_Ping.fadeOutTimer/MINIMAPPING_FADE_TIMER))
		else
			BFC_Ping.fadeOut = nil;
			BFC_Ping:Hide();
		end
	end
 end

function BFC_Ping_FadeOut()
	BFC_Ping.fadeOut = 1;
	BFC_Ping.fadeOutTimer = MINIMAPPING_FADE_TIMER;
end

function BFC_LoadCommanderButtonTextures(name)
	this:RegisterForClicks("LeftButtonUp");
	local prefix = "Interface\\Addons\\BattlefieldCommander\\";
	getglobal(this:GetName() .. "Icon"):SetTexture(prefix..name);
	--this:SetPushedTexture(prefix..name.."-Down");
	--this:SetDisabledTexture(prefix..name.."-Disabled");
	--this:SetHighlightTexture("Interface\\Buttons\\UI-MicroButton-Hilight");
end

function BFC_ObjectiveButton_OnLoad()
	this.state = 0;
end

function BFC_ObjectiveButton_UpdateState()
	if ( this:GetButtonState() == "NORMAL" ) then
		this:SetButtonState("PUSHED");
	else
		this:SetButtonState("NORMAL");
	end
end

function BFC_CommanderFrame_OnLoad()

	for i = 1,8 do
		getglobal("BFC_GroupButton" .. i .. "Text"):SetText(GROUP .. " " .. i);
		getglobal("BFC_GroupButton" .. i).num = i;
	end

end

function BFC_GroupButton_OnClick()
	if(not IsControlKeyDown()) then
		for i = 1,8 do
			if(i ~= this.num) then
				getglobal("BFC_GroupButton" .. i):SetChecked(false);
			end
		end
	end
end

function BFC_ShowObjectiveDropDown(x,y)

	HideDropDownMenu(1);
	
	if(GetNumRaidMembers() > 0 and not (IsRaidLeader() or IsRaidOfficer())) then return end

	BFC_ObjectiveDropDown.initialize = BFC_ObjectiveDropDown_Initialize;
	BFC_ObjectiveDropDown.displayMode = "MENU";
	BFC_ObjectiveDropDown.name = BFC_Strings["objectives"];
	BFC_ObjectiveDropDown.x = x;
	BFC_ObjectiveDropDown.y = y;
	ToggleDropDownMenu(1, nil, BFC_ObjectiveDropDown, "cursor");

end

function BFC_ObjectiveDropDown_Initialize()
	-- Add dropdown title
	info = {};
	info.text = BFC_ObjectiveDropDown.name;
	info.isTitle = 1;
	info.notCheckable = 1;
	UIDropDownMenu_AddButton(info);

	local index = 0;
	-- Show the buttons which are used by this menu
	info = {};
	info.text = BFC_Strings["attack"];
	info.value = index;
	info.func = BFC_ObjectiveDropDownClick;
	info.notCheckable = 1;
	UIDropDownMenu_AddButton(info);
	index = index + 1;
	
	info = {};
	info.text = BFC_Strings["defend"];
	info.value = index;
	info.func = BFC_ObjectiveDropDownClick;
	info.notCheckable = 1;
	UIDropDownMenu_AddButton(info);
	index = index + 1;
	
	info = {};
	info.text = BFC_Strings["move"];
	info.value = index;
	info.func = BFC_ObjectiveDropDownClick;
	info.notCheckable = 1;
	UIDropDownMenu_AddButton(info);
	index = index + 1;
	
	info = {};
	info.text = BFC_Strings["clearobjectives"];
	info.value = index;
	info.func = BFC_ObjectiveDropDownClick;
	info.notCheckable = 1;
	UIDropDownMenu_AddButton(info);
	index = index + 1;
	
	info = {};
	info.text = CANCEL;
	info.value = index;
	info.func = BFC_ObjectiveDropDownClick;
	info.notCheckable = 1;
	UIDropDownMenu_AddButton(info);


	PlaySound("igMainMenuOpen");
end

function BFC_ObjectiveDropDownClick()
	local index = this.value;
	local x = BFC_ObjectiveDropDown.x;
	local y = BFC_ObjectiveDropDown.y;
	
	if(index == 0) then
		BFC_PlaceObjective("sword",x,y);
	elseif(index == 1) then
		BFC_PlaceObjective("shield",x,y);
	elseif(index == 2) then
		BFC_PlaceObjective("cross",x,y);
	elseif(index == 3) then
		for i = 1,8 do
			if(getglobal("BFC_GroupButton" .. i ):GetChecked()) then
				BFC_SendChannelMessage("CLER " .. i);
			end
		end;
	end
	
	PlaySound("UChatScrollButton");
end

function BFC_CanSendObjective(author)
	if(UnitName("player") == author) then
		return true;
	end
	
	if(GetNumRaidMembers() > 0) then
		if(BFC_RaidRoster[author] == nil or (BFC_RaidRoster[author] ~= nil and BFC_RaidRoster[author].rank == 0)) then
			return false;
		else
			return true;
		end
	elseif(GetNumPartyMembers() > 0) then
		if(UnitName("party1") == author or UnitName("party2") == author or UnitName("party3") == author or UnitName("party4") == author) then
			return true;
		else
			return false;
		end
	else
		return true;
	end
end

function BFC_CanSendStatusUpdate(author)
	if(UnitName("player") == author) then
		return true;
	end
	
	if(GetNumRaidMembers() > 0) then
		if(BFC_RaidRoster[author] == nil) then
			return false;
		else
			return true;
		end
	elseif(GetNumPartyMembers() > 0) then
		if(UnitName("party1") == author or UnitName("party2") == author or UnitName("party3") == author or UnitName("party4") == author) then
			return true;
		else
			return false;
		end
	else
		return true;
	end
end

-- update the raid roster cache whenever the raid composition changes
function BFC_UpdateRaidRoster()
	--BFC_Print("doing raid update");
	BFC_NewRaidRoster = {};
	local numRaidMembers = GetNumRaidMembers();
	for i=1, MAX_RAID_MEMBERS do
		--if ( i <= numRaidMembers ) then
			local name, rank, subgroup, level, class, fileName, zone, online, isDead = GetRaidRosterInfo(i);
			if(name ~= nil) then
				
				local pinfo = {};
				pinfo.rank = rank;
				pinfo.class = class;
				pinfo.subgroup = subgroup;
				BFC_NewRaidRoster[name] = pinfo;
				--BFC_Print("added " .. name);
			end
			
		--end
	end
	
	BFC_RaidRoster = BFC_NewRaidRoster;
	
	if(numRaidMembers > 0 and (IsRaidLeader() or IsRaidOfficer())) then
		BFC_ExpandCommanderButton:Show();
	else
		BFC_ExpandCommanderButton:Hide();
	end
end

function BFC_ColorizeRaidIcons()

	--name, rank, subgroup = GetRaidRosterInfo(this:GetID());
	--playername, playerrank, playersubgroup = GetRaidRosterInfo(GetNumRaidMembers());
	
	local partyMemberFrame;
	local playerCount = 0;
	
	-- Color group members
	if ( GetNumRaidMembers() > 0 ) then
		for i=1, MAX_RAID_MEMBERS do
			partyMemberFrame = getglobal("BattlefieldMinimapRaid" .. (playerCount + 1) .. "Icon");
			if ( (partyX ~= 0 or partyY ~= 0) and not UnitIsUnit("raid"..i, "player") ) then
				if(UnitAffectingCombat("raid"..i)) then
					partyMemberFrame:SetTexture(BFC_MiscIcons["combat"]);
				elseif(UnitIsDeadOrGhost("raid"..i)) then
					partyMemberFrame:SetTexture(BFC_MiscIcons["dead"]);
				elseif(BFC_RaidRoster[UnitName("raid"..i)] and BFC_RaidRoster[UnitName("player")]) then
					if(BFC_RaidRoster[UnitName("raid"..i)].subgroup == BFC_RaidRoster[UnitName("player")].subgroup) then
						partyMemberFrame:SetTexture("Interface\\WorldMap\\WorldMapPlayerIcon");
						getglobal("BattlefieldMinimapRaid" .. (playerCount + 1)).samegroup = true;
					else
						partyMemberFrame:SetTexture(BFC_GroupIcons[BFC_RaidRoster[UnitName("raid"..i)].subgroup]);
						getglobal("BattlefieldMinimapRaid" .. (playerCount + 1)).samegroup = false;
					end
				else
					getglobal("BattlefieldMinimapRaid"..(playerCount + 1).."Icon"):SetTexture("Interface\\WorldMap\\WorldMapPartyIcon");
				end
				playerCount = playerCount + 1;
			end
		end
	else
		for i=1, MAX_PARTY_MEMBERS do
			if(UnitAffectingCombat("party"..i)) then
				getglobal("BattlefieldMinimapParty"..i.."Icon"):SetTexture(BFC_MiscIcons["combat"]);
			elseif(UnitIsDeadOrGhost("party"..i)) then
				getglobal("BattlefieldMinimapParty"..i.."Icon"):SetTexture(BFC_MiscIcons["dead"]);
			else
				getglobal("BattlefieldMinimapParty"..i.."Icon"):SetTexture("Interface\\WorldMap\\WorldMapPlayerIcon");
			end
		end
	end
	
	-- Color team members
	local numTeamMembers = GetNumBattlefieldPositions();
	for i=playerCount+1, MAX_RAID_MEMBERS do
		getglobal("BattlefieldMinimapRaid"..i.."Icon"):SetTexture("Interface\\WorldMap\\WorldMapPartyIcon");
		getglobal("BattlefieldMinimapRaid" .. i).samegroup = false;
	end
end

